<?php

/*
 
 File: lib/mysql.lib.php3
 $Author: chuck $
 $Revision: 1.31 $
 $Date: 1998/12/17 21:39:13 $
 
 IMP: Copyright 1998 Charles J. Hagenbuch <chuck@horde.org>
 
 You should have received a copy of the GNU Public
 License along with this package; if not, write to the
 Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.
 
 */

/* Table Structure for MySQL version:
 
 Preferences Table:
 field:     type:        description:
 user       text         joe@imap.doe.com format username
 sig        text         signature
 fullname   text         'Joe Doe' 
 replyto    text         joe@doe.com format
 lang       varchar(30)  users's preferred language (en, es, ...)
 (possibly more to be added later)
 
 Address Table:
 field:     type:      description:
 user       text       joe@doe.com identifier of who this entry belongs to
 address    text       address@mail.server.com - the actual address
 nickname   text       any entered nickname - ie "bonnie".
 fullname   text       full name - "My Bonnie".
 */


/* Required Functions - funtions that are called by other files and therefore
 * must be present in all db.lib implementations
 */

function imp_check_prefs($user,$server) {
   /* Checks for an existing prefs line in the db.
    Returns true or false. */
   
   global $default;
   
   $sql="select user from $default->db_pref_table where user='$user@$server'";
   if (!($db = mysql_pconnect($default->db_server_name,
			      $default->db_user_name, $default->db_password))) { 
      return false; 
   }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, $sql, $db))) { return false; }
   if (mysql_num_rows($result)>0) return true;
   else return false;
}

function imp_get_from ($user, $server) {
   global $default;
   
   if(!imp_check_prefs($user,$server)) return false;
   
   /* post: returns the replyto for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "select replyto from $default->db_pref_table where user='$user@$server'", $db))) { return false; }
   if (mysql_num_rows($result)>0)
     return(mysql_result($result, 0, 0));
   else
     return false;
}

function imp_get_fullname ($user, $server) {
   global $default;
   
   if(!imp_check_prefs($user,$server)) return false;
   
   /* post: returns the fullname for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "select fullname from $default->db_pref_table where user='$user@$server'", $db))) { return false; }
   
   if (mysql_num_rows($result)>0)
     return(mysql_result($result, 0, 0));
   else
     return false;
}

function imp_get_signature ($user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $pref_table; */
   global $default;
   
   if(!imp_check_prefs($user,$server)) return false;
   
   /* post: returns the signature for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "select sig from $default->db_pref_table where user='$user@$server'", $db))) { return false; }
   if (mysql_num_rows($result)>0)
     return(mysql_result($result, 0, 0));
   else
     return false;
}

function imp_set_from ($from, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $pref_table; */
   global $default;
   
   /* post: sets the signature to $signature for the database key $user@$server
    returns true on success and false on failure
    */
   
   if(!(imp_check_prefs($user,$server))) {
      $sql = "insert into $default->db_pref_table (user, replyto) values ('$user@$server','$from')";
   } else {
      $sql = "update $default->db_pref_table set replyto='$from' where user='$user@$server'";
   }
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, $sql, $db))) { return false; }
   
   return true;
}

function imp_set_fullname ($fullname, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $pref_table;*/
   global $default;
   
   /* post: sets the signature to $signature for the database key $user@$server
    returns true on success and false on failure
    */
   
   if(imp_check_prefs($user,$server)) {
      $sql = "update $default->db_pref_table set fullname='$fullname' where user='$user@$server'";
   } else {
      $sql = "insert into $default->db_pref_table (user, fullname) values ('$user@$server','$fullname')";
   }
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, $sql, $db))) { return false; }
   
   return true;
}

function imp_get_lang ($user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $pref_table;*/
   global $default;
   
   /* post: returns the signature for the database key $user@$server
    (a string), or false on failure.
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "select lang from $default->db_pref_table where user='$user@$server'", $db))) { return false; }
   
   if (mysql_num_rows($result)>0)
     return(mysql_result($result, 0, 0));
   else
     return false;
}

function imp_set_signature ($signature, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $pref_table;*/
   global $default;
   
   /* post: sets the signature to $signature for the database key $user@$server
    returns true on success and false on failure
    */
   
   if(imp_check_prefs($user,$server)) {
      $sql = "update $default->db_pref_table set sig='$signature' where user='$user@$server'";
   } else {
      $sql = "insert into $default->db_pref_table (user, sig) values ('$user@$server', '$signature')";
   }
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, $sql, $db))) { return false; }
   
   return true;
}

function imp_set_lang ($lang, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $pref_table;*/
   global $default;
   
   /* post: sets the language to $lang for the database key $user@$server
    returns true on success and false on failure
    */
   
   if (imp_check_prefs($user, $server)) {
      $sql = "update $default->db_pref_table set lang='$lang' where user='$user@$server'";
   } else {
      $sql = "insert into $default->db_pref_table (user, lang) values ('$user@$server', '$lang')";
   }
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, $sql, $db))) { return false; }
   
   return true;
}

function imp_get_addresses ($user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $address_table;*/
   global $default;
   
   /* post: returns a 2d array of addresses where each
    element is an array in which element 0 is the address,
    element 1 is the nickname, and element 2 is the fullname.
    it returns false on failure.
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "select address, nickname, fullname from $default->db_address_table where user='$user@$server' order by nickname", $db))) { return false; }
   
   while ($rows = mysql_fetch_row($result)) {
      $return[] = $rows;
   }
   if(isset($return))
     return($return);
   else
     return(false);
}

function imp_delete_address ($address, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $address_table;*/
   global $default;
   
   /* post: deletes $address from the addressbook of $user@$server
    returns true on success and false on failure
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "delete from $default->db_address_table where user='$user@$server' and address='$address'", $db))) { return false; }
   
   return true;
}

function imp_add_address ($address, $nickname, $fullname, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $address_table;*/
   global $default;
   
   /* post: adds $address, $nickname, $fullname to the addressbook for $user@$server
    returns true on success and false on failure
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "insert into $default->db_address_table values ('$user@$server', '$address', '$nickname', '$fullname')", $db))) { return false; }
   
   return true;
}


function imp_update_address ($old_address, $address, $nickname, $fullname, $user, $server) {
   /*   global $imp_db, $db_server, $db_user, $db_pass, $address_table;*/
   global $default;
   
   /* post: changes the entry for $old_address to $address, $nickname, $fullname.
    returns true on success and false on failure
    */
   
   if (!($db = mysql_pconnect($default->db_server_name, $default->db_user_name, $default->db_password))) { return false; }
   if (!($imp = mysql_select_db($default->db_name, $db))) { return false; }
   if (!($result = mysql_db_query($default->db_name, "update $default->db_address_table set address='$address', nickname='$nickname', fullname='$fullname' where user='$user@$server' and address='$old_address'", $db))) { return false; }
   
   return true;
}


function log_event( $user, $target, $event, $log, $md5 ) {
   global $default;
   if( ! $default->log->enabled ) { return true; }
   
   if( !($db = mysql_pconnect("localhost","www-data")) ) {
      status("Error in LOG __FILE__(__LINE__): DB not found."); 
      return false;
   }
   if( !($dbs = mysql_select_db("imp",$db)) ) {
      status("Error in LOG __FILE__(__LINE__): Can't select DB."); 
      return false;
   }
   $res = mysql_db_query("imp","insert into imp_log values ('$user',now(),$event,'$target','$log','$md5')",$db);
   if( !$res ) {
      status( "error committing log information");
   }
   mysql_free_result($res);  
}

/* Support Functions - functions which are only used by routines in this file,
 * and which therefore can change from implementation to implementation.
 */

?>
